Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90	(revision 3605)
@@ -1792,10 +1952,4 @@
 #endif
        ENDIF
-       !
-       ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-       ! Nouvelle initialisation pour le rayonnement RRTM
-       ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-       CALL iniradia(klon,klev,paprs(1,1:klev+1))
 
        !$omp single
@@ -1815,14 +1969,14 @@
 
        !albedo SB >>>
-       select case(nsw)
-       case(2)
+       SELECT CASE(nsw)
+       CASE(2)
           SFRWL(1)=0.45538747
           SFRWL(2)=0.54461211
-       case(4)
+       CASE(4)
           SFRWL(1)=0.45538747
           SFRWL(2)=0.32870591
           SFRWL(3)=0.18568763
           SFRWL(4)=3.02191470E-02
-       case(6)
+       CASE(6)
           SFRWL(1)=1.28432794E-03
           SFRWL(2)=0.12304168
@@ -1831,5 +1985,5 @@
           SFRWL(5)=0.18568763
           SFRWL(6)=3.02191470E-02
-       end select
+       END SELECT
 
 
@@ -1870,4 +2024,6 @@
       sollwdown(:)= sollwdown(:) + betalwoff *(-1.*ZFLDN0(:,1) - &
                     sollwdown(:))
+
+
     ENDIF
     !
@@ -1891,5 +2047,5 @@
     ! on the surface fraction.
     !
-    CALL change_srf_frac(itap, dtime, days_elapsed+1,  &
+    CALL change_srf_frac(itap, phys_tstep, days_elapsed+1,  &
          pctsrf, fevap, z0m, z0h, agesno,              &
          falb_dir, falb_dif, ftsol, ustar, u10m, v10m, pbl_tke)
@@ -1903,5 +2059,4 @@
 #endif
     ENDIF
-
 
     ! Tendances bidons pour les processus qui n'affectent pas certaines
@@ -2005,4 +2160,13 @@
        ENDDO
     ENDIF
+!
+! Temporary solutions adressing ticket #104 and the non initialisation of tr_ancien
+! LF
+    IF (debut) THEN
+      WRITE(lunout,*)' WARNING: tr_ancien initialised to tr_seri'
+      DO iq = nqo+1, nqtot
+           tr_ancien(:,:,iq-nqo)=tr_seri(:,:,iq-nqo)
+      ENDDO
+    ENDIF
     !
     DO i = 1, klon
@@ -2021,20 +2185,20 @@
     IF (ancien_ok) THEN
     !
-       d_u_dyn(:,:)  = (u_seri(:,:)-u_ancien(:,:))/dtime
-       d_v_dyn(:,:)  = (v_seri(:,:)-v_ancien(:,:))/dtime
-       d_t_dyn(:,:)  = (t_seri(:,:)-t_ancien(:,:))/dtime
-       d_q_dyn(:,:)  = (q_seri(:,:)-q_ancien(:,:))/dtime
-       d_ql_dyn(:,:) = (ql_seri(:,:)-ql_ancien(:,:))/dtime
-       d_qs_dyn(:,:) = (qs_seri(:,:)-qs_ancien(:,:))/dtime
+       d_u_dyn(:,:)  = (u_seri(:,:)-u_ancien(:,:))/phys_tstep
+       d_v_dyn(:,:)  = (v_seri(:,:)-v_ancien(:,:))/phys_tstep
+       d_t_dyn(:,:)  = (t_seri(:,:)-t_ancien(:,:))/phys_tstep
+       d_q_dyn(:,:)  = (q_seri(:,:)-q_ancien(:,:))/phys_tstep
+       d_ql_dyn(:,:) = (ql_seri(:,:)-ql_ancien(:,:))/phys_tstep
+       d_qs_dyn(:,:) = (qs_seri(:,:)-qs_ancien(:,:))/phys_tstep
        CALL water_int(klon,klev,q_seri,zmasse,zx_tmp_fi2d)
-       d_q_dyn2d(:)=(zx_tmp_fi2d(:)-prw_ancien(:))/dtime
+       d_q_dyn2d(:)=(zx_tmp_fi2d(:)-prw_ancien(:))/phys_tstep
        CALL water_int(klon,klev,ql_seri,zmasse,zx_tmp_fi2d)
-       d_ql_dyn2d(:)=(zx_tmp_fi2d(:)-prlw_ancien(:))/dtime
+       d_ql_dyn2d(:)=(zx_tmp_fi2d(:)-prlw_ancien(:))/phys_tstep
        CALL water_int(klon,klev,qs_seri,zmasse,zx_tmp_fi2d)
-       d_qs_dyn2d(:)=(zx_tmp_fi2d(:)-prsw_ancien(:))/dtime
+       d_qs_dyn2d(:)=(zx_tmp_fi2d(:)-prsw_ancien(:))/phys_tstep
        ! !! RomP >>>   td dyn traceur
        IF (nqtot.GT.nqo) THEN     ! jyg
           DO iq = nqo+1, nqtot      ! jyg
-              d_tr_dyn(:,:,iq-nqo)=(tr_seri(:,:,iq-nqo)-tr_ancien(:,:,iq-nqo))/dtime ! jyg
+              d_tr_dyn(:,:,iq-nqo)=(tr_seri(:,:,iq-nqo)-tr_ancien(:,:,iq-nqo))/phys_tstep ! jyg
           ENDDO
        ENDIF
@@ -2138,5 +2302,5 @@
                       ro3i, 'C', press_cen_climoz, pplay, wo, paprs(:,1),    &
                       time_climoz )
-          END IF
+          ENDIF
           ! Convert from mole fraction of ozone to column density of ozone in a
           ! cell, in kDU:
@@ -2158,5 +2322,5 @@
             (du0,dv0,d_t_eva,d_q_eva,d_ql_eva,d_qi_eva,paprs,&
                'eva',abortphy,flag_inhib_tend,itap,0)
-    call prt_enerbil('eva',itap)
+    CALL prt_enerbil('eva',itap)
 
     !=========================================================================
@@ -2213,5 +2377,5 @@
           !  bit comparable a l ancienne formulation cycle_diurne=true
           !  on integre entre gmtime et gmtime+radpas
-          zdtime=dtime*REAL(radpas) ! pas de temps du rayonnement (s)
+          zdtime=phys_tstep*REAL(radpas) ! pas de temps du rayonnement (s)
           CALL zenang(zlongi,jH_cur,0.0,zdtime, &
                latitude_deg,longitude_deg,rmu0,fract)
@@ -2230,6 +2394,6 @@
           !  premier pas de temps de la physique pendant lequel
           !  itaprad=0
-          zdtime1=dtime*REAL(-MOD(itaprad,radpas)-1)      
-          zdtime2=dtime*REAL(radpas-MOD(itaprad,radpas)-1) 
+          zdtime1=phys_tstep*REAL(-MOD(itaprad,radpas)-1)      
+          zdtime2=phys_tstep*REAL(radpas-MOD(itaprad,radpas)-1) 
           CALL zenang(zlongi,jH_cur,zdtime1,zdtime2, &
                latitude_deg,longitude_deg,rmu0,fract)
@@ -2237,5 +2401,5 @@
           ! Calcul des poids
           !
-          zdtime1=-dtime !--on corrige le rayonnement pour representer le
+          zdtime1=-phys_tstep !--on corrige le rayonnement pour representer le
           zdtime2=0.0    !--pas de temps de la physique qui se termine
           CALL zenang(zlongi,jH_cur,zdtime1,zdtime2, &
@@ -2295,4 +2459,7 @@
        !
        !-------gustiness calculation-------!
+       !ym : Warning gustiness non inialized for iflag_gusts=2 & iflag_gusts=3
+       gustiness=0  !ym missing init
+       
        IF (iflag_gusts==0) THEN
           gustiness(1:klon)=0
@@ -2312,8 +2479,6 @@
        ENDIF
 
-
-
        CALL pbl_surface(  &
-            dtime,     date0,     itap,    days_elapsed+1, &
+            phys_tstep,     date0,     itap,    days_elapsed+1, &
             debut,     lafin, &
             longitude_deg, latitude_deg, rugoro,  zrmu0,      &
@@ -2382,7 +2547,20 @@
        ENDIF
 
-
-
-
+!add limitation for t,q at and wind at 10m
+        if ( iflag_bug_t2m_ipslcm61 == 0 ) THEN
+          CALL borne_var_surf( klon,klev,nbsrf,                 &
+            iflag_bug_t2m_stab_ipslcm61,                        &
+            t_seri(:,1),q_seri(:,1),u_seri(:,1),v_seri(:,1),    &
+            ftsol,zxqsurf,pctsrf,paprs,                         &
+            t2m, q2m, u10m, v10m,                               &
+            zt2m_cor, zq2m_cor, zu10m_cor, zv10m_cor,           &
+            zrh2m_cor, zqsat2m_cor)
+        ELSE
+          zt2m_cor(:)=zt2m(:)
+          zq2m_cor(:)=zq2m(:)
+          zu10m_cor(:)=zu10m(:)
+          zv10m_cor(:)=zv10m(:)
+          zqsat2m_cor=999.999
+        ENDIF
 
        !---------------------------------------------------------------------
@@ -2397,5 +2575,5 @@
                'vdf',abortphy,flag_inhib_tend,itap,0)
        ENDIF
-       call prt_enerbil('vdf',itap)
+       CALL prt_enerbil('vdf',itap)
        !--------------------------------------------------------------------
 
@@ -2482,7 +2660,7 @@
        DO i = 1, klon
           conv_q(i,k) = d_q_dyn(i,k)  &
-               + d_q_vdf(i,k)/dtime
+               + d_q_vdf(i,k)/phys_tstep
           conv_t(i,k) = d_t_dyn(i,k)  &
-               + d_t_vdf(i,k)/dtime
+               + d_t_vdf(i,k)/phys_tstep
        ENDDO
     ENDDO
@@ -2528,4 +2706,5 @@
     pmflxs(:,:) = 0.
     wdtrainA(:,:) = 0.
+    wdtrainS(:,:) = 0.
     wdtrainM(:,:) = 0.
     upwd(:,:) = 0.
@@ -2543,4 +2722,5 @@
     elij(:,:,:)=0.
     ev(:,:)=0.
+    qtaa(:,:)=0.
     clw(:,:)=0.
     sij(:,:,:)=0.
@@ -2549,9 +2729,9 @@
        abort_message ='reactiver le call conlmd dans physiq.F'
        CALL abort_physic (modname,abort_message,1)
-       !     CALL conlmd (dtime, paprs, pplay, t_seri, q_seri, conv_q,
+       !     CALL conlmd (phys_tstep, paprs, pplay, t_seri, q_seri, conv_q,
        !    .             d_t_con, d_q_con,
        !    .             rain_con, snow_con, ibas_con, itop_con)
     ELSE IF (iflag_con.EQ.2) THEN
-       CALL conflx(dtime, paprs, pplay, t_seri, q_seri, &
+       CALL conflx(phys_tstep, paprs, pplay, t_seri, q_seri, &
             conv_t, conv_q, -evap, omega, &
             d_t_con, d_q_con, rain_con, snow_con, &
@@ -2629,5 +2809,5 @@
 
 !jyg<
-       CALL alpale( debut, itap, dtime, paprs, omega, t_seri,   &
+       CALL alpale( debut, itap, phys_tstep, paprs, omega, t_seri,   &
                     alp_offset, it_wape_prescr,  wape_prescr, fip_prescr, &
                     ale_bl_prescr, alp_bl_prescr, &
@@ -2671,5 +2851,5 @@
           !c          CALL concvl (iflag_con,iflag_clos,
           CALL concvl (iflag_clos, &
-               dtime, paprs, pplay, k_upper_cv, t_x,q_x, &
+               phys_tstep, paprs, pplay, k_upper_cv, t_x,q_x, &
                t_w,q_w,wake_s, &
                u_seri,v_seri,tr_seri,nbtr_tmp, &
@@ -2679,13 +2859,13 @@
                rain_con, snow_con, ibas_con, itop_con, sigd, &
                ema_cbmf,plcl,plfc,wbeff,convoccur,upwd,dnwd,dnwd0, &
-               Ma,mip,Vprecip,cape,cin,tvp,Tconv,iflagctrl, &
+               Ma,mipsh,Vprecip,cape,cin,tvp,Tconv,iflagctrl, &
                pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,qcondc,wd, &
                                 ! RomP >>>
                                 !!     .        pmflxr,pmflxs,da,phi,mp,
                                 !!     .        ftd,fqd,lalim_conv,wght_th)
-               pmflxr,pmflxs,da,phi,mp,phi2,d1a,dam,sij,clw,elij, &
+               pmflxr,pmflxs,da,phi,mp,phi2,d1a,dam,sij,qtaa,clw,elij, &
                ftd,fqd,lalim_conv,wght_th, &
                ev, ep,epmlmMm,eplaMm, &
-               wdtrainA,wdtrainM,wght_cvfd,qtc_cv,sigt_cv, &
+               wdtrainA, wdtrainS, wdtrainM,wght_cvfd,qtc_cv,sigt_cv, &
                tau_cld_cv,coefw_cld_cv,epmax_diag)
 
@@ -2741,6 +2921,6 @@
               DO k=1,klev
                  DO i=1,klon
-                    ftd(i,k) = ftd(i,k) + wake_s(i)*d_t_adjwk(i,k)/dtime
-                    fqd(i,k) = fqd(i,k) + wake_s(i)*d_q_adjwk(i,k)/dtime
+                    ftd(i,k) = ftd(i,k) + wake_s(i)*d_t_adjwk(i,k)/phys_tstep
+                    fqd(i,k) = fqd(i,k) + wake_s(i)*d_q_adjwk(i,k)/phys_tstep
                     d_t_con(i,k) = d_t_con(i,k) + wake_s(i)*d_t_adjwk(i,k)
                     d_q_con(i,k) = d_q_con(i,k) + wake_s(i)*d_q_adjwk(i,k)
@@ -2754,5 +2934,5 @@
 
           ! MAF conema3 ne contient pas les traceurs
-          CALL conema3 (dtime, &
+          CALL conema3 (phys_tstep, &
                paprs,pplay,t_seri,q_seri, &
                u_seri,v_seri,tr_seri,ntra, &
@@ -2865,5 +3045,5 @@
     CALL add_phys_tend(d_u_con, d_v_con, d_t_con, d_q_con, dql0, dqi0, paprs, &
          'convection',abortphy,flag_inhib_tend,itap,0)
-    call prt_enerbil('convection',itap)
+    CALL prt_enerbil('convection',itap)
 
     !-------------------------------------------------------------------------
@@ -2886,5 +3066,5 @@
                snow_con(i))*cell_area(i)/REAL(klon)
        ENDDO
-       zx_t = zx_t/za*dtime
+       zx_t = zx_t/za*phys_tstep
        WRITE(lunout,*)"Precip=", zx_t
     ENDIF
@@ -2900,5 +3080,5 @@
        ENDDO
        DO i = 1, klon
-          z_factor(i) = (z_avant(i)-(rain_con(i)+snow_con(i))*dtime) &
+          z_factor(i) = (z_avant(i)-(rain_con(i)+snow_con(i))*phys_tstep) &
                /z_apres(i)
        ENDDO
@@ -2937,6 +3117,6 @@
                 M_dwn(i,k)   = dnwd0(i,k)
                 M_up(i,k)    = upwd(i,k)
-                dt_a(i,k)    = d_t_con(i,k)/dtime - ftd(i,k) 
-                dq_a(i,k)    = d_q_con(i,k)/dtime - fqd(i,k)
+                dt_a(i,k)    = d_t_con(i,k)/phys_tstep - ftd(i,k) 
+                dq_a(i,k)    = d_q_con(i,k)/phys_tstep - fqd(i,k)
              ENDDO
           ENDDO
@@ -2946,7 +3126,7 @@
              DO k = 1,klev
                 dt_dwn(:,k)= dt_dwn(:,k)+ &
-                     ok_wk_lsp(:)*(d_t_eva(:,k)+d_t_lsc(:,k))/dtime
+                     ok_wk_lsp(:)*(d_t_eva(:,k)+d_t_lsc(:,k))/phys_tstep
                 dq_dwn(:,k)= dq_dwn(:,k)+ &
-                     ok_wk_lsp(:)*(d_q_eva(:,k)+d_q_lsc(:,k))/dtime
+                     ok_wk_lsp(:)*(d_q_eva(:,k)+d_q_lsc(:,k))/phys_tstep
              ENDDO
           ELSEIF (iflag_wake==3) THEN
@@ -2959,7 +3139,7 @@
                       ! l'eau se reevapore).
                       dt_dwn(i,k)= dt_dwn(i,k)+ &
-                           ok_wk_lsp(i)*d_t_lsc(i,k)/dtime
+                           ok_wk_lsp(i)*d_t_lsc(i,k)/phys_tstep
                       dq_dwn(i,k)= dq_dwn(i,k)+ &
-                           ok_wk_lsp(i)*d_q_lsc(i,k)/dtime
+                           ok_wk_lsp(i)*d_q_lsc(i,k)/phys_tstep
                    ENDIF
                 ENDDO
@@ -2969,5 +3149,5 @@
           !
           !calcul caracteristiques de la poche froide
-          CALL calWAKE (iflag_wake_tend, paprs, pplay, dtime, &
+          CALL calWAKE (iflag_wake_tend, paprs, pplay, phys_tstep, &
                t_seri, q_seri, omega,  &
                dt_dwn, dq_dwn, M_dwn, M_up,  &
@@ -2996,5 +3176,5 @@
        CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,paprs,'wake', &
             abortphy,flag_inhib_tend,itap,0)
-       call prt_enerbil('wake',itap)
+       CALL prt_enerbil('wake',itap)
        !------------------------------------------------------------------------
 
@@ -3005,5 +3185,5 @@
             (d_deltat_wk, d_deltaq_wk, d_s_wk, d_dens_a_wk, d_dens_wk, wake_k, &
              'wake', abortphy) 
-          call prt_enerbil('wake',itap)
+          CALL prt_enerbil('wake',itap)
        ENDIF   ! (iflag_wake_tend .GT. 0.)
        !
@@ -3016,5 +3196,5 @@
        IF (iflag_alp_wk_cond .GT. 0.) THEN
 
-         CALL alpale_wk(dtime, cell_area, wake_k, wake_s, wake_dens, wake_fip_0, &
+         CALL alpale_wk(phys_tstep, cell_area, wake_k, wake_s, wake_dens, wake_fip_0, &
                         wake_fip)
        ELSE
@@ -3147,5 +3327,5 @@
                    (d_deltat_the, d_deltaq_the, dsig0, ddens0, ddens0, wake_k, 'the', abortphy) 
              ENDIF
-             call prt_enerbil('the',itap)
+             CALL prt_enerbil('the',itap)
           !
           ENDIF  ! (mod(iflag_pbl_split/10,10) .GE. 1)
@@ -3153,8 +3333,8 @@
           CALL add_phys_tend(d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs,  &
                              dql0,dqi0,paprs,'thermals', abortphy,flag_inhib_tend,itap,0)
-          call prt_enerbil('thermals',itap)
+          CALL prt_enerbil('thermals',itap)
           !
 !
-          CALL alpale_th( dtime, lmax_th, t_seri, cell_area,  &
+          CALL alpale_th( phys_tstep, lmax_th, t_seri, cell_area,  &
                           cin, s2, n2,  &
                           ale_bl_trig, ale_bl_stat, ale_bl,  &
@@ -3216,5 +3396,5 @@
           CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,paprs, &
                'ajsb',abortphy,flag_inhib_tend,itap,0)
-          call prt_enerbil('ajsb',itap)
+          CALL prt_enerbil('ajsb',itap)
           d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_ajsb(:,:)
           d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_ajsb(:,:)
@@ -3246,5 +3426,5 @@
     ENDIF
     !
-    CALL fisrtilp(dtime,paprs,pplay, &
+    CALL fisrtilp(phys_tstep,paprs,pplay, &
          t_seri, q_seri,ptconv,ratqs, &
          d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, cldliq, &
@@ -3267,5 +3447,5 @@
     CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,paprs, &
          'lsc',abortphy,flag_inhib_tend,itap,0)
-    call prt_enerbil('lsc',itap)
+    CALL prt_enerbil('lsc',itap)
     rain_num(:)=0.
     DO k = 1, klev
@@ -3306,5 +3486,5 @@
                + snow_lsc(i))*cell_area(i)/REAL(klon)
        ENDDO
-       zx_t = zx_t/za*dtime
+       zx_t = zx_t/za*phys_tstep
        WRITE(lunout,*)"Precip=", zx_t
     ENDIF
@@ -3526,11 +3706,9 @@
        calday = REAL(days_elapsed + 1) + jH_cur
 
-       CALL chemtime(itap+itau_phy-1, date0, dtime, itap)
-       IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
-          CALL AEROSOL_METEO_CALC( &
-               calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
-               prfl,psfl,pctsrf,cell_area, &
-               latitude_deg,longitude_deg,u10m,v10m)
-       ENDIF
+       CALL chemtime(itap+itau_phy-1, date0, phys_tstep, itap)
+       CALL AEROSOL_METEO_CALC( &
+            calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
+            prfl,psfl,pctsrf,cell_area, &
+            latitude_deg,longitude_deg,u10m,v10m)
 
        zxsnow_dummy(:) = 0.0
@@ -3615,5 +3793,5 @@
 #else
                    !--climatologies or INCA aerosols
-                   CALL readaerosol_optic_rrtm( debut, aerosol_couple, ok_alw, &
+                   CALL readaerosol_optic_rrtm( debut, aerosol_couple, ok_alw, ok_volcan, &
                         new_aod, flag_aerosol, flag_bc_internal_mixture, itap, jD_cur-jD_ref, &
                         pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
@@ -3705,5 +3883,5 @@
              CALL readaerosolstrato1_rrtm(debut)
             ELSEIF (flag_aerosol_strat.EQ.2) THEN
-             CALL readaerosolstrato2_rrtm(debut)
+             CALL readaerosolstrato2_rrtm(debut, ok_volcan)
             ELSE
              abort_message='flag_aerosol_strat must equal 1 or 2 for rrtm=1'
@@ -3717,4 +3895,6 @@
 #endif
           ENDIF
+       ELSE
+          tausum_aero(:,:,id_STRAT_phy) = 0. 
        ENDIF
 !
@@ -3895,9 +4075,13 @@
           RCFC11 = RCFC11_act
           RCFC12 = RCFC12_act
+          ! 
+          !--interactive CO2 in ppm from carbon cycle
+          IF (carbon_cycle_rad.AND..NOT.debut) THEN
+            RCO2=RCO2_glo
+          ENDIF
           !
           IF (prt_level .GE.10) THEN
              print *,' ->radlwsw, number 1 '
           ENDIF
-
           !
           CALL radlwsw &
@@ -3909,5 +4093,6 @@
                t_seri,q_seri,wo, &
                cldfrarad, cldemirad, cldtaurad, &
-               ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie, flag_aerosol, &
+               ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie,  ok_volcan, &
+               flag_aerosol, &
                flag_aerosol_strat, flag_aer_feedback, &
                tau_aero, piz_aero, cg_aero, &
@@ -3920,4 +4105,5 @@
                ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
                heat,heat0,cool,cool0,albpla, &
+               heat_volc,cool_volc, &
                topsw,toplw,solsw,sollw, &
                sollwdown, &
@@ -3994,5 +4180,6 @@
                      t_seri,q_seri,wo, &
                      cldfrarad, cldemirad, cldtaurad, &
-                     ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie, flag_aerosol, &
+                     ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie,  ok_volcan, &
+                     flag_aerosol, &
                      flag_aerosol_strat, flag_aer_feedback, &
                      tau_aero, piz_aero, cg_aero, &
@@ -4005,4 +4192,5 @@
                      ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
                      heatp,heat0p,coolp,cool0p,albplap, &
+                     heat_volc,cool_volc, &
                      topswp,toplwp,solswp,sollwp, &
                      sollwdownp, &
@@ -4072,14 +4260,14 @@
 
     DO k=1, klev
-       d_t_swr(:,k)=swradcorr(:)*heat(:,k)*dtime/RDAY
-       d_t_sw0(:,k)=swradcorr(:)*heat0(:,k)*dtime/RDAY
-       d_t_lwr(:,k)=-cool(:,k)*dtime/RDAY
-       d_t_lw0(:,k)=-cool0(:,k)*dtime/RDAY
+       d_t_swr(:,k)=swradcorr(:)*heat(:,k)*phys_tstep/RDAY
+       d_t_sw0(:,k)=swradcorr(:)*heat0(:,k)*phys_tstep/RDAY
+       d_t_lwr(:,k)=-cool(:,k)*phys_tstep/RDAY
+       d_t_lw0(:,k)=-cool0(:,k)*phys_tstep/RDAY
     ENDDO
 
     CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy,flag_inhib_tend,itap,0)
-    call prt_enerbil('SW',itap)
+    CALL prt_enerbil('SW',itap)
     CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy,flag_inhib_tend,itap,0)
-    call prt_enerbil('LW',itap)
+    CALL prt_enerbil('LW',itap)
 
     !
@@ -4131,5 +4319,5 @@
        IF (ok_strato) THEN
 
-          CALL drag_noro_strato(0,klon,klev,dtime,paprs,pplay, &
+          CALL drag_noro_strato(0,klon,klev,phys_tstep,paprs,pplay, &
                zmea,zstd, zsig, zgam, zthe,zpic,zval, &
                igwd,idx,itest, &
@@ -4139,5 +4327,5 @@
 
        ELSE
-          CALL drag_noro(klon,klev,dtime,paprs,pplay, &
+          CALL drag_noro(klon,klev,phys_tstep,paprs,pplay, &
                zmea,zstd, zsig, zgam, zthe,zpic,zval, &
                igwd,idx,itest, &
@@ -4152,5 +4340,5 @@
        CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro', &
             abortphy,flag_inhib_tend,itap,0)
-       call prt_enerbil('oro',itap)
+       CALL prt_enerbil('oro',itap)
        !----------------------------------------------------------------------
        !
@@ -4180,5 +4368,5 @@
        IF (ok_strato) THEN
 
-          CALL lift_noro_strato(klon,klev,dtime,paprs,pplay, &
+          CALL lift_noro_strato(klon,klev,phys_tstep,paprs,pplay, &
                latitude_deg,zmea,zstd,zpic,zgam,zthe,zpic,zval, &
                igwd,idx,itest, &
@@ -4188,5 +4376,5 @@
 
        ELSE
-          CALL lift_noro(klon,klev,dtime,paprs,pplay, &
+          CALL lift_noro(klon,klev,phys_tstep,paprs,pplay, &
                latitude_deg,zmea,zstd,zpic, &
                itest, &
@@ -4199,5 +4387,5 @@
        CALL add_phys_tend(d_u_lif, d_v_lif, d_t_lif, dq0, dql0, dqi0, paprs, &
             'lif', abortphy,flag_inhib_tend,itap,0)
-       call prt_enerbil('lif',itap)
+       CALL prt_enerbil('lif',itap)
     ENDIF ! fin de test sur ok_orolf
 
@@ -4208,5 +4396,5 @@
        du_gwd_hines=0.
        dv_gwd_hines=0.
-       CALL hines_gwd(klon, klev, dtime, paprs, pplay, latitude_deg, t_seri, &
+       CALL hines_gwd(klon, klev, phys_tstep, paprs, pplay, latitude_deg, t_seri, &
             u_seri, v_seri, zustr_gwd_hines, zvstr_gwd_hines, d_t_hin, &
             du_gwd_hines, dv_gwd_hines)
@@ -4214,7 +4402,7 @@
        zvstr_gwd_hines=0.
        DO k = 1, klev
-          zustr_gwd_hines(:)=zustr_gwd_hines(:)+ du_gwd_hines(:, k)/dtime &
+          zustr_gwd_hines(:)=zustr_gwd_hines(:)+ du_gwd_hines(:, k)/phys_tstep &
                * (paprs(:, k)-paprs(:, k+1))/rg
-          zvstr_gwd_hines(:)=zvstr_gwd_hines(:)+ dv_gwd_hines(:, k)/dtime &
+          zvstr_gwd_hines(:)=zvstr_gwd_hines(:)+ dv_gwd_hines(:, k)/phys_tstep &
                * (paprs(:, k)-paprs(:, k+1))/rg
        ENDDO
@@ -4223,9 +4411,10 @@
        CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, &
             dqi0, paprs, 'hin', abortphy,flag_inhib_tend,itap,0)
-       call prt_enerbil('hin',itap)
+       CALL prt_enerbil('hin',itap)
     ENDIF
 
     IF (.not. ok_hines .and. ok_gwd_rando) then
-       CALL acama_GWD_rando(DTIME, pplay, latitude_deg, t_seri, u_seri, &
+       ! ym missing init for east_gwstress & west_gwstress -> added in phys_local_var_mod
+       CALL acama_GWD_rando(PHYS_TSTEP, pplay, latitude_deg, t_seri, u_seri, &
             v_seri, rot, zustr_gwd_front, zvstr_gwd_front, du_gwd_front, &
             dv_gwd_front, east_gwstress, west_gwstress)
@@ -4233,7 +4422,7 @@
        zvstr_gwd_front=0.
        DO k = 1, klev
-          zustr_gwd_front(:)=zustr_gwd_front(:)+ du_gwd_front(:, k)/dtime &
+          zustr_gwd_front(:)=zustr_gwd_front(:)+ du_gwd_front(:, k)/phys_tstep &
                * (paprs(:, k)-paprs(:, k+1))/rg
-          zvstr_gwd_front(:)=zvstr_gwd_front(:)+ dv_gwd_front(:, k)/dtime &
+          zvstr_gwd_front(:)=zvstr_gwd_front(:)+ dv_gwd_front(:, k)/phys_tstep &
                * (paprs(:, k)-paprs(:, k+1))/rg
        ENDDO
@@ -4241,20 +4430,20 @@
        CALL add_phys_tend(du_gwd_front, dv_gwd_front, dt0, dq0, dql0, dqi0, &
             paprs, 'front_gwd_rando', abortphy,flag_inhib_tend,itap,0)
-       call prt_enerbil('front_gwd_rando',itap)
+       CALL prt_enerbil('front_gwd_rando',itap)
     ENDIF
 
     IF (ok_gwd_rando) THEN
-       CALL FLOTT_GWD_rando(DTIME, pplay, t_seri, u_seri, v_seri, &
+       CALL FLOTT_GWD_rando(PHYS_TSTEP, pplay, t_seri, u_seri, v_seri, &
             rain_fall + snow_fall, zustr_gwd_rando, zvstr_gwd_rando, &
             du_gwd_rando, dv_gwd_rando, east_gwstress, west_gwstress)
        CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, dqi0, &
             paprs, 'flott_gwd_rando', abortphy,flag_inhib_tend,itap,0)
-       call prt_enerbil('flott_gwd_rando',itap)
+       CALL prt_enerbil('flott_gwd_rando',itap)
        zustr_gwd_rando=0.
        zvstr_gwd_rando=0.
        DO k = 1, klev
-          zustr_gwd_rando(:)=zustr_gwd_rando(:)+ du_gwd_rando(:, k)/dtime &
+          zustr_gwd_rando(:)=zustr_gwd_rando(:)+ du_gwd_rando(:, k)/phys_tstep &
                * (paprs(:, k)-paprs(:, k+1))/rg
-          zvstr_gwd_rando(:)=zvstr_gwd_rando(:)+ dv_gwd_rando(:, k)/dtime &
+          zvstr_gwd_rando(:)=zvstr_gwd_rando(:)+ dv_gwd_rando(:, k)/phys_tstep &
                * (paprs(:, k)-paprs(:, k+1))/rg
        ENDDO
@@ -4276,7 +4465,7 @@
     DO k = 1, klev
        DO i = 1, klon
-          zustrph(i)=zustrph(i)+(u_seri(i,k)-u(i,k))/dtime* &
+          zustrph(i)=zustrph(i)+(u_seri(i,k)-u(i,k))/phys_tstep* &
                (paprs(i,k)-paprs(i,k+1))/rg
-          zvstrph(i)=zvstrph(i)+(v_seri(i,k)-v(i,k))/dtime* &
+          zvstrph(i)=zvstrph(i)+(v_seri(i,k)-v(i,k))/phys_tstep* &
                (paprs(i,k)-paprs(i,k+1))/rg
        ENDDO
@@ -4296,11 +4485,11 @@
     !IM cf. FLott END
     !DC Calcul de la tendance due au methane
-    IF(ok_qch4) THEN
+    IF (ok_qch4) THEN
        CALL METHOX(1,klon,klon,klev,q_seri,d_q_ch4,pplay)
        ! ajout de la tendance d'humidite due au methane
-       d_q_ch4_dtime(:,:) = d_q_ch4(:,:)*dtime
+       d_q_ch4_dtime(:,:) = d_q_ch4(:,:)*phys_tstep
        CALL add_phys_tend(du0, dv0, dt0, d_q_ch4_dtime, dql0, dqi0, paprs, &
             'q_ch4', abortphy,flag_inhib_tend,itap,0)
-       d_q_ch4(:,:) = d_q_ch4_dtime(:,:)/dtime
+       d_q_ch4(:,:) = d_q_ch4_dtime(:,:)/phys_tstep
     ENDIF
     !
@@ -4313,6 +4502,4 @@
 ! Inititialization
 !------------------
-
-    
 
        addtkeoro=0   
@@ -4326,13 +4513,11 @@
        alphatkeoro=min(max(0.,alphatkeoro),1.)
 
-       smallscales_tkeoro=.false.   
+       smallscales_tkeoro=.FALSE.   
        CALL getin_p('smallscales_tkeoro',smallscales_tkeoro) 
 
 
-        dtadd(:,:)=0.
-        duadd(:,:)=0.
-        dvadd(:,:)=0.
-
-
+       dtadd(:,:)=0.
+       duadd(:,:)=0.
+       dvadd(:,:)=0.
 
 ! Choices for addtkeoro:
@@ -4349,5 +4534,4 @@
 
 
-
   IF (addtkeoro .EQ. 1 ) THEN
 
@@ -4357,7 +4541,5 @@
   ELSE IF (addtkeoro .EQ. 2) THEN
 
-
-
-       IF (smallscales_tkeoro) THEN
+     IF (smallscales_tkeoro) THEN
        igwd=0
        DO i=1,klon
@@ -4382,13 +4564,10 @@
              igwd=igwd+1
              idx(igwd)=i
-          ENDIF
-       ENDDO
-
-       END IF
-
-
-
-
-       CALL drag_noro_strato(addtkeoro,klon,klev,dtime,paprs,pplay, &
+        ENDIF
+       ENDDO
+
+     ENDIF
+
+     CALL drag_noro_strato(addtkeoro,klon,klev,phys_tstep,paprs,pplay, &
                zmea,zstd, zsig, zgam, zthe,zpic,zval, &
                igwd,idx,itest, &
@@ -4397,13 +4576,12 @@
                d_t_oro_gw, d_u_oro_gw, d_v_oro_gw)
 
-            zustrdr(:)=0.
-            zvstrdr(:)=0.
-            zulow(:)=0.
-            zvlow(:)=0.
-
-            duadd(:,:)=alphatkeoro*d_u_oro_gw(:,:)
-            dvadd(:,:)=alphatkeoro*d_v_oro_gw(:,:)
- END IF
-    
+     zustrdr(:)=0.
+     zvstrdr(:)=0.
+     zulow(:)=0.
+     zvlow(:)=0.
+
+     duadd(:,:)=alphatkeoro*d_u_oro_gw(:,:)
+     dvadd(:,:)=alphatkeoro*d_v_oro_gw(:,:)
+  ENDIF
 
 
@@ -4416,9 +4594,7 @@
 
 
-
        ENDIF
 !      -----
 !===============================================================
-
 
 
@@ -4431,5 +4607,5 @@
        ! adeclarer 
 #ifdef CPP_COSP
-       IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/dtime)).EQ.0) THEN
+       IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/phys_tstep)).EQ.0) THEN
 
           IF (prt_level .GE.10) THEN
@@ -4439,5 +4615,5 @@
           !       print*,'Dans physiq.F avant appel cosp ref_liq,ref_ice=',
           !     s        ref_liq,ref_ice
-          CALL phys_cosp(itap,dtime,freq_cosp, &
+          CALL phys_cosp(itap,phys_tstep,freq_cosp, &
                ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
                ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
@@ -4462,5 +4638,5 @@
 
 #ifdef CPP_COSP2
-       IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/dtime)).EQ.0) THEN
+       IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/phys_tstep)).EQ.0) THEN
 
           IF (prt_level .GE.10) THEN
@@ -4470,5 +4646,5 @@
                  print*,'Dans physiq.F avant appel '
           !     s        ref_liq,ref_ice
-          CALL phys_cosp2(itap,dtime,freq_cosp, &
+          CALL phys_cosp2(itap,phys_tstep,freq_cosp, &
                ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
                ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
@@ -4485,4 +4661,28 @@
 #endif
 
+#ifdef CPP_COSPV2
+       IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/phys_tstep)).EQ.0) THEN
+
+          IF (prt_level .GE.10) THEN
+             print*,'freq_cosp',freq_cosp
+          ENDIF
+          mr_ozone=wo(:, :, 1) * dobson_u * 1e3 / zmasse
+                 print*,'Dans physiq.F avant appel '
+          !     s        ref_liq,ref_ice
+          CALL lmdz_cosp_interface(itap,phys_tstep,freq_cosp, &
+               ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
+               klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
+               JrNt,ref_liq,ref_ice, &
+               pctsrf(:,is_ter)+pctsrf(:,is_lic), &
+               zu10m,zv10m,pphis, &
+               zphi,paprs(:,1:klev),pplay,zxtsol,t_seri, &
+               qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
+               prfl(:,1:klev),psfl(:,1:klev), &
+               pmflxr(:,1:klev),pmflxs(:,1:klev), &
+               mr_ozone,cldtau, cldemi)
+       ENDIF
+#endif
+
     ENDIF  !ok_cosp
 
@@ -4492,5 +4692,5 @@
   IF (ok_airs) then
 
-  IF (itap.eq.1.or.MOD(itap,NINT(freq_airs/dtime)).EQ.0) THEN
+  IF (itap.eq.1.or.MOD(itap,NINT(freq_airs/phys_tstep)).EQ.0) THEN
      write(*,*) 'je vais appeler simu_airs, ok_airs, freq_airs=', ok_airs, freq_airs
      CALL simu_airs(itap,rneb, t_seri, cldemi, fiwc, ref_ice, pphi, pplay, paprs,&
@@ -4547,5 +4747,5 @@
     CALL phytrac ( &
          itap,     days_elapsed+1,    jH_cur,   debut, &
-         lafin,    dtime,     u, v,     t, &
+         lafin,    phys_tstep,     u, v,     t, &
          paprs,    pplay,     pmfu,     pmfd, &
          pen_u,    pde_u,     pen_d,    pde_d, &
@@ -4582,5 +4782,5 @@
             cdragh,coefh(1:klon,1:klev,is_ave),u1,v1,ftsol,pctsrf, &
             frac_impa, frac_nucl, &
-            pphis,cell_area,dtime,itap, &
+            pphis,cell_area,phys_tstep,itap, &
             qx(:,:,ivap),da,phi,mp,upwd,dnwd)
 
@@ -4653,5 +4853,5 @@
 
        CALL chemhook_end ( &
-            dtime, &
+            phys_tstep, &
             pplay, &
             t_seri, &
